javax.media.j3d

## Class ShaderError

- java.lang.Object
- - javax.media.j3d.ShaderError

-     public class ShaderError
      extends java.lang.Object

  ShaderError is a container object that holds the details of a runtime error that occurs while compiling or executing a programmable shader.
  Since:
    Java 3D 1.4

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `COMPILE_ERROR` Indicates that an error occurred while compiling a shader.
    `static int` | `LINK_ERROR` Indicates that an error occurred while linking a shader.
    `static int` | `NO_ERROR` Indicates that no error occurred.
    `static int` | `SHADER_ATTRIBUTE_LOOKUP_ERROR` Indicates a error in looking up the location of a uniform shader attribute name within a given shader program.
    `static int` | `SHADER_ATTRIBUTE_NAME_NOT_SET_ERROR` Indicates a error caused by a ShaderAttribute whose name does not appear in the list of shader attribute names in the corresponding ShaderProgram object.
    `static int` | `SHADER_ATTRIBUTE_TYPE_ERROR` Indicates a error in the type of the attribute versus what the shader program was expecting.
    `static int` | `UNSUPPORTED_LANGUAGE_ERROR` Indicates that the specified shading language is not supported on the screen display device.
    `static int` | `VERTEX_ATTRIBUTE_LOOKUP_ERROR` Indicates a error in looking up a vertex attribute name within a given shader program.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ShaderError()` Constructs a new ShaderError object indicating no error.
    `ShaderError(int errorCode, java.lang.String errorMessage)` Constructs a new ShaderError object with the given error code and message.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Canvas3D` | `getCanvas3D()` Returns the canvas associated with this shader error.
    `java.lang.String` | `getDetailMessage()` Returns the detail message for this shader error.
    `int` | `getErrorCode()` Returns the error code for this shader error.
    `java.lang.String` | `getErrorMessage()` Returns the error message for this shader error.
    `Geometry` | `getGeometry()` Returns the geometry associated with this shader error.
    `Shader` | `getShader()` Returns the shader object associated with this shader error.
    `ShaderAppearance` | `getShaderAppearance()` Returns the shader appearance associated with this shader error.
    `ShaderAttribute` | `getShaderAttribute()` Returns the shader attribute associated with this shader error.
    `ShaderAttributeSet` | `getShaderAttributeSet()` Returns the shader attribute set associated with this shader error.
    `ShaderProgram` | `getShaderProgram()` Returns the shader program associated with this shader error.
    `Shape3D` | `getShape3D()` Returns the shape node associated with this shader error.
    `void` | `printVerbose()` Prints a verbose error report to System.err.
    `void` | `printVerbose(java.io.PrintStream printStream)` Prints a verbose error report to the specified PrintStream.
    `void` | `setCanvas3D(Canvas3D canvas)` Sets the canvas associated with this shader error.
    `void` | `setDetailMessage(java.lang.String detailMessage)` Sets the detail message for this shader error.
    `void` | `setErrorCode(int errorCode)` Sets the error code for this shader error.
    `void` | `setErrorMessage(java.lang.String errorMessage)` Sets the error message for this shader error.
    `void` | `setGeometry(Geometry geometry)` Sets the geometry associated with this shader error.
    `void` | `setShader(Shader shader)` Sets the shader object associated with this shader error.
    `void` | `setShaderAppearance(ShaderAppearance shaderApp)` Sets the shader appearance associated with this shader error.
    `void` | `setShaderAttribute(ShaderAttribute shaderAttribute)` Sets the shader attribute associated with this shader error.
    `void` | `setShaderAttributeSet(ShaderAttributeSet shaderAttributeSet)` Sets the shader attribute set associated with this shader error.
    `void` | `setShaderProgram(ShaderProgram shaderProgram)` Sets the shader program associated with this shader error.
    `void` | `setShape3D(Shape3D shape)` Sets the shape node associated with this shader error.
    `java.lang.String` | `toString()` Returns a short string that describes this shader error.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### NO_ERROR

          public static final int NO_ERROR

      Indicates that no error occurred.
      See Also:
        Constant Field Values

    - #### COMPILE_ERROR

          public static final int COMPILE_ERROR

      Indicates that an error occurred while compiling a shader.
      See Also:
        Constant Field Values

    - #### LINK_ERROR

          public static final int LINK_ERROR

      Indicates that an error occurred while linking a shader.
      See Also:
        Constant Field Values

    - #### VERTEX_ATTRIBUTE_LOOKUP_ERROR

          public static final int VERTEX_ATTRIBUTE_LOOKUP_ERROR

      Indicates a error in looking up a vertex attribute name within a given shader program.
      See Also:
        Constant Field Values

    - #### SHADER_ATTRIBUTE_LOOKUP_ERROR

          public static final int SHADER_ATTRIBUTE_LOOKUP_ERROR

      Indicates a error in looking up the location of a uniform shader attribute name within a given shader program.
      See Also:
        Constant Field Values

    - #### SHADER_ATTRIBUTE_NAME_NOT_SET_ERROR

          public static final int SHADER_ATTRIBUTE_NAME_NOT_SET_ERROR

      Indicates a error caused by a ShaderAttribute whose name does not appear in the list of shader attribute names in the corresponding ShaderProgram object.
      See Also:
        Constant Field Values

    - #### SHADER_ATTRIBUTE_TYPE_ERROR

          public static final int SHADER_ATTRIBUTE_TYPE_ERROR

      Indicates a error in the type of the attribute versus what the shader program was expecting.
      See Also:
        Constant Field Values

    - #### UNSUPPORTED_LANGUAGE_ERROR

          public static final int UNSUPPORTED_LANGUAGE_ERROR

      Indicates that the specified shading language is not supported on the screen display device.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ShaderError

          public ShaderError()

      Constructs a new ShaderError object indicating no error. The error code is set to `NO_ERROR`. All other fields are initialized to null, including the error message.

    - #### ShaderError

          public ShaderError(int errorCode,
                     java.lang.String errorMessage)

      Constructs a new ShaderError object with the given error code and message. All other fields are initialized to null.
      Parameters:
        `errorCode` - the error code for this shader error.
        `errorMessage` - a short error message describing this shader error.

  - ### Method Detail

    - #### printVerbose

          public void printVerbose()

      Prints a verbose error report to System.err. This verbose output includes the error code, error message, detail message, and all relevant Java 3D objects.

    - #### printVerbose

          public void printVerbose(java.io.PrintStream printStream)

      Prints a verbose error report to the specified PrintStream. This verbose output includes the error code, error message, detail message, and all relevant Java 3D objects.
      Parameters:
        `printStream` - the print stream on which to print the error report.

    - #### setErrorCode

          public void setErrorCode(int errorCode)

      Sets the error code for this shader error. This represents the type of error that occurred.
      Parameters:
        `errorCode` - the error code for this shader error.

    - #### getErrorCode

          public int getErrorCode()

      Returns the error code for this shader error.
      Returns:
        the error code.

    - #### setErrorMessage

          public void setErrorMessage(java.lang.String errorMessage)

      Sets the error message for this shader error. This is a short message describing the error, and is included as part of toString().
      Parameters:
        `errorMessage` - a short error message describing this shader error.

    - #### getErrorMessage

          public java.lang.String getErrorMessage()

      Returns the error message for this shader error.
      Returns:
        a short error message describing this shader error.

    - #### setDetailMessage

          public void setDetailMessage(java.lang.String detailMessage)

      Sets the detail message for this shader error. This is a detailed error message, typically produced by the shader compiler, and is not included as part of toString().
      Parameters:
        `detailMessage` - a detailed message describing this shader error in more detail.

    - #### getDetailMessage

          public java.lang.String getDetailMessage()

      Returns the detail message for this shader error.
      Returns:
        the detail message for this shader error.

    - #### setCanvas3D

          public void setCanvas3D(Canvas3D canvas)

      Sets the canvas associated with this shader error.
      Parameters:
        `canvas` - the canvas associated with this shader error.

    - #### getCanvas3D

          public Canvas3D getCanvas3D()

      Returns the canvas associated with this shader error.
      Returns:
        the canvas associated with this shader error.

    - #### setShape3D

          public void setShape3D(Shape3D shape)

      Sets the shape node associated with this shader error.
      Parameters:
        `shape` - the shape node associated with this shader error.

    - #### getShape3D

          public Shape3D getShape3D()

      Returns the shape node associated with this shader error.
      Returns:
        the shape node associated with this shader error.

    - #### setGeometry

          public void setGeometry(Geometry geometry)

      Sets the geometry associated with this shader error.
      Parameters:
        `geometry` - the geometry associated with this shader error.

    - #### getGeometry

          public Geometry getGeometry()

      Returns the geometry associated with this shader error.
      Returns:
        the geometry associated with this shader error.

    - #### setShaderAppearance

          public void setShaderAppearance(ShaderAppearance shaderApp)

      Sets the shader appearance associated with this shader error.
      Parameters:
        `shaderApp` - the shader appearance associated with this shader error.

    - #### getShaderAppearance

          public ShaderAppearance getShaderAppearance()

      Returns the shader appearance associated with this shader error.
      Returns:
        the shader appearance associated with this shader error.

    - #### setShaderProgram

          public void setShaderProgram(ShaderProgram shaderProgram)

      Sets the shader program associated with this shader error.
      Parameters:
        `shaderProgram` - the shader program associated with this shader error.

    - #### getShaderProgram

          public ShaderProgram getShaderProgram()

      Returns the shader program associated with this shader error.
      Returns:
        the shader program associated with this shader error.

    - #### setShader

          public void setShader(Shader shader)

      Sets the shader object associated with this shader error.
      Parameters:
        `shader` - the shader object associated with this shader error.

    - #### getShader

          public Shader getShader()

      Returns the shader object associated with this shader error.
      Returns:
        the shader object associated with this shader error.

    - #### setShaderAttributeSet

          public void setShaderAttributeSet(ShaderAttributeSet shaderAttributeSet)

      Sets the shader attribute set associated with this shader error.
      Parameters:
        `shaderAttributeSet` - the shader attribute set associated with this shader error.

    - #### getShaderAttributeSet

          public ShaderAttributeSet getShaderAttributeSet()

      Returns the shader attribute set associated with this shader error.
      Returns:
        the shader attribute set associated with this shader error.

    - #### setShaderAttribute

          public void setShaderAttribute(ShaderAttribute shaderAttribute)

      Sets the shader attribute associated with this shader error.
      Parameters:
        `shaderAttribute` - the shader attribute associated with this shader error.

    - #### getShaderAttribute

          public ShaderAttribute getShaderAttribute()

      Returns the shader attribute associated with this shader error.
      Returns:
        the shader attribute associated with this shader error.

    - #### toString

          public java.lang.String toString()

      Returns a short string that describes this shader error. The string is composed of the textual description of the errorCode, a ": ", and the errorMessage field. If the errorMessage is null then the ": " and the errorMessage are omitted.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a string representation of this shader error.

Copyright 1996-2008 Sun Microsystems, Inc. All Rights Reserved. Use is subject to license terms.